# Button Buddy

## Goal

A hand-wired macro-pad using a Raspberry Pi Zero, cherry-style switches, and a 3D printed case.

## Why?

I've got a spare Pi Zero, a bunch of spare kailh box jade switches and keycaps, and a 3D printer, and I want a little macropad that I can use for (among other things) mouse buttons next to my Ploopy Nano.

## How?

Case and switch plate will be rendered using OpenSCAD, probably 2 rows of 3 (right, left, middle click, a scroll-mode toggle, and two extra buttons maybe for copy/paste macros or whatever else I decide is more useful).

The Pi Zero will be programmed with gpiozero I guess? That's the part I'm least familiar with.

## Concerns

The lamest things are than my Pi Zero is the model with no built-in storage, so it'll have to use one of my spare SD cards too. It's wi-fi though so maybe it can serve a dual purpose as a controller for the macropad as well as some kind of server. Or maybe if I get super ambitious I can throw a LiPo in there and make the whole thing wireless, sending its events to some kind of daemon on my computer. Probably not. I dunno. Since it's a Zero and not a Pico or some other microcontroller it's going to have to boot up every time the power is interrupted which takes a minute, which is kind of lame, but I'll be using it on my desktop machine which also has to boot up so that's NBD.

## Resources

- [Turn Your Raspberry Pi Zero into a USB Keyboard (HID)](https://randomnerdtutorials.com/raspberry-pi-zero-usb-keyboard-hid/)
- [USB Keyboard Emulation with the Raspberry Pi Zero](https://www.makerhacks.com/usb-keyboard-emulation-with-the-raspberry-pi-zero/)
- [Getting started with gpiozero](https://dronebotworkshop.com/raspberry-pi-gpio/)
